#!/bin/sh
# Usage: install.sh <path_to_JRE> 
#
# Example:
#   install.sh /usr/java/default
# 

if [ -z "$1" ]; then
	printf "USAGE: install.sh path_to_JRE\n"
	osascript -e "tell app \"System Events\" to display dialog \"Используйте команду вида: install.sh путь_до_JRE\" buttons \"OK\" default button 1 with title \"Ошибка установки\" with icon caution"
	exit 1
fi

JREDIR=$1
JAVACMD="$JREDIR/bin/java"
[ -x "$JAVACMD" ] || {
	printf "File not found: $JAVACMD\n"
	osascript -e "tell app \"System Events\" to display dialog \"Не найден файл $JAVACMD\" buttons \"OK\" default button 1 with title \"Ошибка установки\" with icon caution"
	exit 1
}

"$JAVACMD" -version 

if [ -f "/System/Library/Java/Extensions/libAPDUStub.dylib" ] ||  [ -f "/System/Library/Java/Extensions/libJaCartaTerminal.dylib" ]; then
	csrutil_path=$(which csrutil)
	res=$?

	if [ "$res" -eq "0" ]; then
		csrutil_status=$(csrutil status | awk '/status/ {print $5}' | sed 's/\.$//')
		if [ $csrutil_status = "enabled" ]; then
			echo "Installation ERROR: "
			echo "  You must disable 'System Integrity Protection' to continue installation"
                               
			osascript -e "tell app \"System Events\" to display dialog \"Для продолжения установки необходимо отключить System Integrity Protection\" buttons \"OK\" default button 1 with title \"Ошибка установки\" with icon caution"
                               
			exit 1
		fi
	fi
	
	for i in libAPDUStub.dylib libJaCartaTerminal.dylib; do
		rm -f "/System/Library/Java/Extensions/$i"
		if [ -r "/System/Library/Java/Extensions/$i" ]; then
			printf "This file is locked:\n"
			printf "/System/Library/Java/Extensions/$i\n"
			printf "Stop all processes that use this files and retry\n"
			exit 1
		fi
	done
fi

for i in JaCarta_for_CryptoPro_JCP.jar JaCarta_Terminal.jar; do
    rm -f "$JREDIR/lib/ext/$i"
    if [ -r "$JREDIR/lib/ext/$i" ]; then
		printf "JVM is running or jar-files are locked:\n"
        printf "$JREDIR/lib/ext/$i\n"
		printf "Stop all processes that use Java and retry\n"
        exit 1
    fi
    cp $i "$JREDIR/lib/ext/$i"
done

for i in libAPDUStub.dylib libJaCartaTerminal.dylib; do
    rm -f "/Library/Java/Extensions/$i"
    if [ -r "/Library/Java/Extensions/$i" ]; then
		printf "This file is locked:\n"
        printf "/Library/Java/Extensions/$i\n"
	printf "Stop all processes that use this files and retry\n"
	exit 1
    fi
    cp $i "/Library/Java/Extensions/$i"
done

for i in opencard.properties; do

	for i in opencard.properties; do

	# if there is a file
	if ( test -e "$JREDIR/lib/$i" ); then

		TMPFILE='mktemp' || exit 1

		# comment old content and add new
		sed 's/\(^[^#]\)/#\1/' "$JREDIR/lib/$i" > $TMPFILE
		sed -n '/^#/!p' $i >> $TMPFILE

		rm -f "$JREDIR/lib/$i"
		if [ -r "$JREDIR/lib/$i" ]; then
			printf "this file is locked:\n"
			printf "$JREDIR/lib/$i\n"
			printf "Stop all processes that use this file and retry\n"
			exit 1
		fi
		mv $TMPFILE "$JREDIR/lib/$i"
		
	else
		cp $i "$JREDIR/lib/$i"
	fi
	
done
	
done

printf "Successful\n"