#!/bin/sh
# Usage: install_J6CF.sh <path_to_JRE> 
#
# Example:
#   install_J6CF.sh /usr/java/default
# 

if [ -z "$1" ]; then
	printf "USAGE: install_J6CF.sh path_to_JRE\n"
	osascript -e "tell app \"System Events\" to display dialog \"Используйте команду вида: install_J6CF.sh путь_до_JRE\" buttons \"OK\" default button 1 with title \"Ошибка установки\" with icon caution"
	exit 1
fi

JREDIR=$1
JAVACMD="$JREDIR/bin/java"
[ -x "$JAVACMD" ] || {
	printf "File not found: $JAVACMD\n"
	osascript -e "tell app \"System Events\" to display dialog \"Не найден файл $JAVACMD\" buttons \"OK\" default button 1 with title \"Ошибка установки\" with icon caution"
	exit 1
}

"$JAVACMD" -version 


if [ -f "/System/Library/Java/Extensions/libAPDUStubJ6CF.dylib" ]; then
	csrutil_path=$(which csrutil)
	res=$?

	if [ "$res" -eq "0" ]; then
		csrutil_status=$(csrutil status | awk '/status/ {print $5}' | sed 's/\.$//')
		if [ $csrutil_status = "enabled" ]; then
			echo "Installation ERROR: "
			echo "  You must disable 'System Integrity Protection' to continue installation"
                               
			osascript -e "tell app \"System Events\" to display dialog \"Для продолжения установки необходимо отключить System Integrity Protection\" buttons \"OK\" default button 1 with title \"Ошибка установки\" with icon caution"
                               
			exit 1
		fi
	fi
	
	rm -f "/System/Library/Java/Extensions/libAPDUStubJ6CF.dylib"
	if [ -r "/System/Library/Java/Extensions/libAPDUStubJ6CF.dylib" ]; then
		printf "This file is locked:\n"
		printf "/System/Library/Java/Extensions/libAPDUStubJ6CF.dylib\n"
		printf "Stop all processes that use this files and retry\n"
		exit 1
	fi
fi

"$JAVACMD" -cp JaCartaJ6CF.jar ru.aladdin.jacarta.cryptopro.jcp.j6cf.Install -install

rm -f "/Library/Java/Extensions/libAPDUStubJ6CF.dylib"
if [ -r "/Library/Java/Extensions/libAPDUStubJ6CF.dylib" ]; then
	printf "This file is locked:\n"
    printf "/Library/Java/Extensions/libAPDUStubJ6CF.dylib\n"
	printf "Stop all processes that use this files and retry\n"
	exit 1
fi
cp libAPDUStubJ6CF.dylib "/Library/Java/Extensions/libAPDUStubJ6CF.dylib"

printf "Successful\n"