#!/bin/sh
# Usage: uninstall.sh <path_to_JRE> 
#
# Example:
#   uninstall.sh /usr/java/default
# 

if [ -z "$1" ]; then
	printf "USAGE: uninstall.sh path_to_JRE\n"
  
    osascript -e "tell app \"System Events\" to display dialog \"Используйте команду вида: uninstall.sh путь_до_JRE\" buttons \"OK\" default button 1 with title \"Ошибка удаления\" with icon caution"
  
  exit 1
fi

JREDIR=$1
JAVACMD="$JREDIR/bin/java"
[ -x "$JAVACMD" ] || {
	printf "File not found: $JAVACMD\n"
  
    osascript -e "tell app \"System Events\" to display dialog \"Не найден файл $JAVACMD\" buttons \"OK\" default button 1 with title \"Ошибка удаления\" with icon caution"
    
  exit 1
}

"$JAVACMD" -version 

for i in JaCarta_for_CryptoPro_JCP.jar JaCarta_Terminal.jar; do
    rm -f "$JREDIR/lib/ext/$i"
    if [ -r "$JREDIR/lib/ext/$i" ]; then
		printf "JVM is running or jar-files are locked:\n"
        printf "$JREDIR/lib/ext/$i\n"
		printf "Stop all processes that use Java and retry\n"
        exit 1
    fi
done

for i in libAPDUStub.so libJaCartaTerminal.so; do
    rm -f "/Library/Java/Extensions/$i"
    if [ -r "/Library/Java/Extensions/$i" ]; then
		printf "This file is locked:\n"
        printf "/Library/Java/Extensions/$i\n"
		printf "Stop all processes that use this files and retry\n"
		exit 1
    fi
   
done

printf "Successful\n"